<?php
error_reporting(E_ALL); 
ini_set('display_errors', TRUE); 
include '../common/global.php';

$pdo 	= Database::connect();

$arrCus=array();
$instMID=$custID=$insGrpId='';
$isValid=1;

if(file_get_contents("php://input"))
{
	$InstrumentData 		= file_get_contents("php://input");
	$InstrumentDataJSON 	= json_decode($InstrumentData);
	$custID			        = $InstrumentDataJSON->custID;
	$insGrpId		        = $InstrumentDataJSON->insGrpId;
	$instMID		        = $InstrumentDataJSON->insModId;
	
}
else
{
	if(isset($_POST['custID']))
	$custID			= $_POST['custID'];
	
	if(isset($_POST['insGrpId']))
	$insGrpId		= $_POST['insGrpId'];
	
	if(isset($_POST['insModId']))
	$instMID		= $_POST['insModId'];
	
}

if($custID=='')
{
    $arrCus['status']="Error";
    $arrCus['message']="Please select customer";
    $isValid=0;
}
if($insGrpId=='')
{
	$arrCus['status']="Error";
    $arrCus['message']="Please select Instrument group";
    $isValid=0;
	
}
if($instMID=='')
{
	$arrCus['status']="Error";
    $arrCus['message']="Please select Instrument Module";
    $isValid=0;
	
}

if($isValid!=0)
{
    if($custID>0)
    {
		try
		{
			 $selSRCustInstrumentsTxt="SELECT DISTINCT ci.InstrumentRecID AS instid,i.InstrumentSrNo AS instrument 
									FROM customer_instrument ci 
									LEFT JOIN instrument i ON ci.InstrumentRecID=i.RecID 
									WHERE ci.CustomerRecID=:custID AND ci.InstrumentGroupRecID=:insGrpID AND ci.InstrumentModelRecID=:inMdlID AND ci.CustInstActive=1 ";

			$selSRCustInstrumentsQry=$pdo->prepare($selSRCustInstrumentsTxt);
			$selSRCustInstrumentsQry->bindValue('custID',$custID);
			$selSRCustInstrumentsQry->bindValue('insGrpID',$insGrpId);
			$selSRCustInstrumentsQry->bindValue('inMdlID',$instMID);
			$selSRCustInstrumentsQry->execute();

			$selSRCustInstrumentsQryDS=$selSRCustInstrumentsQry->fetchAll();

			foreach($selSRCustInstrumentsQryDS as $row)
			{
				$data=array();

				$data['instID']=$row['instid'];
				$data['instrument']=$row['instrument'];

				$arrCus[]=$data;
			}
			
		}
		catch(Exception $e)
		{
			$arrCus['status']="Error";
			$arrCus['message']="Something went wrong!";
			$isValid=0;
			
		}
    }
    else
    {
        $arrCus['status']="Error";
        $arrCus['message']="Customer ID is not valid";
        $isValid=0;
    }
}

echo json_encode($arrCus);
exit;
?>