<?php
error_reporting(E_ALL); 
ini_set('display_errors', TRUE); 
include '../common/global.php';

$pdo 	= Database::connect();

$arrCus=array();
$custID=$insGrpId=$instModel=$mode='';
$isValid=1;

if(file_get_contents("php://input"))
{
	$InstrumentData 		= file_get_contents("php://input");
	$InstrumentDataJSON 	= json_decode($InstrumentData);
	$custID			        = trim($InstrumentDataJSON->custID);               //Customer rec id.
	$insGrpId		        = trim($InstrumentDataJSON->insGrpId);               //instrument group id
    $instModel              = trim($InstrumentDataJSON->instModel);               //instrument model
    $mode                   = trim($InstrumentDataJSON->mode);
}
else
{
	if(isset($_POST['custID']))
	$custID			= trim($_POST['custID']);
	
	if(isset($_POST['insGrpId']))
	$insGrpId		= trim($_POST['insGrpId']);
    
    if(isset($_POST['instModel']))
	$instModel		= trim($_POST['instModel']);
    
    if(isset($_POST['mode']))
	$mode		= trim($_POST['mode']);
	
}

if($mode=='' || ($mode!='new' && $mode!='view'))
{
    $arrCus['status']="Error";
    $arrCus['message']="Invalid Mode!";
    $isValid=0;
}

if($mode=='new')
{
    
    if($insGrpId=='')
    {
        $arrCus['status']="Error";
        $arrCus['message']="Please select Instrument group";
        $isValid=0;

    }
    if($custID=='')
    {
        $arrCus['status']="Error";
        $arrCus['message']="Please select customer";
        $isValid=0;
    }
}

if($isValid!=0)
{
    if($mode=='new' && $custID>0)
    {
        try
        {
            $selSRCustInstModelTxt="SELECT DISTINCT ci.InstrumentModelRecID AS instmid,im.InstrumentModel AS instmodel	
								FROM customer_instrument ci 
								LEFT JOIN instrument_model im ON ci.InstrumentModelRecID=im.RecID
								WHERE ci.CustomerRecID=:custID AND ci.InstrumentGroupRecID=:insGrpId";

            $selSRCustInstModelQry=$pdo->prepare($selSRCustInstModelTxt);
            $selSRCustInstModelQry->bindValue('custID',$custID);
            $selSRCustInstModelQry->bindValue('insGrpId',$insGrpId);
            $selSRCustInstModelQry->execute();

            $selSRCustInstModelQryDS=$selSRCustInstModelQry->fetchAll();

            foreach($selSRCustInstModelQryDS as $row)
            {
                $data=array();

                $data['instMID']=$row['instmid'];
                $data['instModel']=$row['instmodel'];

                $arrCus[]=$data;
            }
        }
        catch(Exception $e)
        {
            $arrCus['status']="Error";
            $arrCus['message']="Something went wrong!";
            $isValid=0;
        }
        
    }
    if($mode=='view' && $instModel!='')
    {
        try
        {
            $selSRCustInstModelTxt="SELECT DISTINCT im.InstrumentModel AS instmodel	
								FROM instrument_model im 
								WHERE im.InstrumentModel LIKE N'%$instModel%'";

            $selSRCustInstModelQry=$pdo->prepare($selSRCustInstModelTxt);
            
            $selSRCustInstModelQry->bindValue('insGrpId',$insGrpId);
            $selSRCustInstModelQry->execute();

            $selSRCustInstModelQryDS=$selSRCustInstModelQry->fetchAll();

            foreach($selSRCustInstModelQryDS as $row)
            {
                $data=array();

                
                $data['instModel']=$row['instmodel'];

                $arrCus[]=$data;
            }
        }
        catch(Exception $e)
        {
            $arrCus['status']="Error";
            $arrCus['message']="Something went wrong!";
            $isValid=0;
        }
        
    }
}

echo json_encode($arrCus);
exit;
?>