<?php
error_reporting(E_ALL); 
ini_set('display_errors', TRUE); 
include '../common/global.php';

$pdo 	= Database::connect();

$arrCus=array();
$instMID=$custID=$insGrpId=$inst=$mode='';
$isValid=1;

if(file_get_contents("php://input"))
{
	$InstrumentData 		= file_get_contents("php://input");
	$InstrumentDataJSON 	= json_decode($InstrumentData);
	$custID			        = trim($InstrumentDataJSON->custID);           //Customer RecID
	$insGrpId		        = trim($InstrumentDataJSON->insGrpId);          //Instrument Group RecID
	$instMID		        = trim($InstrumentDataJSON->insModId);         //Instrument Model RecID
	$inst                   = trim($InstrumentDataJSON->inst);               //instrument sr no.
    $mode                   = trim($InstrumentDataJSON->mode);
}
else
{
	if(isset($_POST['custID']))
	$custID			= trim($_POST['custID']);
	
	if(isset($_POST['insGrpId']))
	$insGrpId		= trim($_POST['insGrpId']);
	
	if(isset($_POST['insModId']))
	$instMID		= trim($_POST['insModId']);
    
    if(isset($_POST['inst']))
	$inst		= trim($_POST['inst']);
    
    if(isset($_POST['mode']))
	$mode		= trim($_POST['mode']);
	
}

if($mode=='' || ($mode!='new' && $mode!='view'))
{
    $arrCus['status']="Error";
    $arrCus['message']="Invalid Mode!";
    $isValid=0;
}


if($mode=='new')
{
    
    
    if($instMID=='')
    {
        $arrCus['status']="Error";
        $arrCus['message']="Please select Instrument Module";
        $isValid=0;

    }
    if($insGrpId=='')
    {
        $arrCus['status']="Error";
        $arrCus['message']="Please select Instrument group";
        $isValid=0;

    }
    if($custID=='')
    {
        $arrCus['status']="Error";
        $arrCus['message']="Please select customer";
        $isValid=0;
    }
}


if($isValid!=0)
{
    if($mode=='new' && $custID>0)//for new record
    {
		try
		{
			 $selSRCustInstrumentsTxt="SELECT DISTINCT ci.InstrumentRecID AS instid,i.InstrumentSrNo AS instrument 
									FROM customer_instrument ci 
									LEFT JOIN instrument i ON ci.InstrumentRecID=i.RecID 
									WHERE ci.CustomerRecID=:custID AND ci.InstrumentGroupRecID=:insGrpID AND ci.InstrumentModelRecID=:inMdlID";

			$selSRCustInstrumentsQry=$pdo->prepare($selSRCustInstrumentsTxt);
			$selSRCustInstrumentsQry->bindValue('custID',$custID);
			$selSRCustInstrumentsQry->bindValue('insGrpID',$insGrpId);
			$selSRCustInstrumentsQry->bindValue('inMdlID',$instMID);
			$selSRCustInstrumentsQry->execute();

			$selSRCustInstrumentsQryDS=$selSRCustInstrumentsQry->fetchAll();

			foreach($selSRCustInstrumentsQryDS as $row)
			{
				$data=array();

				$data['instID']=$row['instid'];
				$data['instrument']=$row['instrument'];

				$arrCus[]=$data;
			}
			
		}
		catch(Exception $e)
		{
			$arrCus['status']="Error";
			$arrCus['message']="Something went wrong!";
			$isValid=0;
			
		}
    }
    
    if($mode=='view' && $inst!='')//for filter view
    {
        try
		{
			 $selSRCustInstrumentsTxt="SELECT DISTINCT i.InstrumentSrNo AS instrument 
									FROM instrument i  
									WHERE i.InstrumentSrNo LIKE N'%$inst%'";

			$selSRCustInstrumentsQry=$pdo->prepare($selSRCustInstrumentsTxt);
			
			
			$selSRCustInstrumentsQry->execute();

			$selSRCustInstrumentsQryDS=$selSRCustInstrumentsQry->fetchAll();

			foreach($selSRCustInstrumentsQryDS as $row)
			{
				$data=array();

				
				$data['instrument']=$row['instrument'];

				$arrCus[]=$data;
			}
			
		}
		catch(Exception $e)
		{
			$arrCus['status']="Error";
			$arrCus['message']="Something went wrong!";
			$isValid=0;
			
		}
    }
}

echo json_encode($arrCus);
exit;
?>